	.include "p30f2012.inc"
	.global	HoseiInit
	.global	HoseiG
	.global	HoseiOfs
	.global	initG

;------------------------------------
;{^Ƃ̒llɂ
;------------------------------------
initG:
	push	w0
	mov	HXYZIN,w0
	mov	w0,GBUF
	mov	HXYZIN+2,w0
	mov	w0,GBUF+2

	clr	w0
	mov	w0,XACCB
	mov	w0,XACCB+2
	mov	w0,XACCB+4
	mov	w0,XACCB+6
	pop	w0
	return

;------------------------------------
;ZT̓ItZbg␳
;------------------------------------
HoseitiO:
	.word -0x03BD		;XaxisvZl
	.word  0
	.word -0x03BB		;YaxisvZl
	.word  0
	.word -0x09B6		;ZaxisvZl
	.word  0

HoseiOfs:
	push	w0
	push	w1
	push	w2
	push	w3
	push	ACCAU
	push	ACCAH
	push	ACCAL
	push	ACCBU
	push	ACCBH
	push	ACCBL

	mov	#psvpage(HoseitiO),w0
	mov	w0,_PSVPAG
	mov	#psvoffset(HoseitiO),w1
	mov	#XINB,w0
	mov	#HXINB,w3
;X axis
	lac	[w0++],A
	mov	[w0++],w2
	mov	w2,ACCAL
	lac	[w1++],B
	mov	[w1++],w2
	mov	w2,ACCBL
	add	A
	sac	A,[w3++]
	mov	ACCAL,w2
	mov	w2,[w3++]
;Y axis
	lac	[w0++],A
	mov	[w0++],w2
	mov	w2,ACCAL
	lac	[w1++],B
	mov	[w1++],w2
	mov	w2,ACCBL
	add	A
	sac	A,[w3++]
	mov	ACCAL,w2
	mov	w2,[w3++]
;Z axis
	lac	[w0++],A
	mov	[w0++],w2
	mov	w2,ACCAL
	lac	[w1++],B
	mov	[w1++],w2
	mov	w2,ACCBL
	add	A
	sac	A,[w3++]
	mov	ACCAL,w2
	mov	w2,[w3++]

	pop	ACCBL
	pop	ACCBH
	pop	ACCBU
	pop	ACCAL
	pop	ACCAH
	pop	ACCAU
	pop	w3
	pop	w2
	pop	w1
	pop	w0
	return

;------------------------------------
;ZT̓QC␳
;------------------------------------
HoseitiG:	;␳l
	.word 32767*25732/28502	;Xaxis gain
	.word 32767*25732/28254	;Yaxis gain
	.word 32767*25732/25732	;Zaxis gain

HoseiG:
	push	w0
	push	w1
	push	w4
	push	w5
	push	w8
	push	w10
	push	ACCAU
	push	ACCAH
	push	ACCAL
	push	ACCBU
	push	ACCBH
	push	ACCBL
	mov	#psvpage(HoseitiG),w0
	mov	w0,_PSVPAG
	mov	#psvoffset(HoseitiG),w1
	mov	#XHOSEIG,w0
	repeat	#2
	mov	[w1++],[w0++]

	mov	#XHOSEIG,w10
	mov	#HXINB+2,w8
;X axis
	clr	A, [w8]-=2,w4, [w10]+=2,w5		;w4=͒l, w5=␳l
	mul.us	w4,w5,w0				;ʌvZ
	mov	w1,ACCAH
	mov	w0,ACCAL
	mov	#1,w0					;ۂ
	add	W0,#1,A
	sftac	A,#16
	movsac	A,	 [w8]+=6,w4
	mac	w4*w5,A, [w8]-=2,w4, [w10]+=2,w5	;ʌvZ
	sac	A,w0
	mov	w0,HXINB2
	mov	ACCAL,w0
	mov	w0,HXINB2+2
;Y axis
	clr	A
	mul.us	w4,w5,w0				;ʌvZ
	mov	w1,ACCAH
	mov	w0,ACCAL
	mov	#1,w0					;ۂ
	add	W0,#1,A
	sftac	A,#16

	movsac	A,	 [w8]+=6,w4
	mac	w4*w5,A, [w8]-=2,w4, [w10]+=2,w5	;ʌvZ
	sac	A,w0
	mov	w0,HYINB2
	mov	ACCAL,w0
	mov	w0,HYINB2+2
;Z axis
	clr	A
	mul.us	w4,w5,w0				;ʌvZ
	mov	w1,ACCAH
	mov	w0,ACCAL
	mov	#1,w0					;ۂ
	add	W0,#1,A
	sftac	A,#16

	movsac	A, 	[w8]+=6,w4
	mac	w4*w5,A					;ʌvZ
	sac	A,w0
	mov	w0,HZINB2
	mov	ACCAL,w0
	mov	w0,HZINB2+2

	pop	ACCBL
	pop	ACCBH
	pop	ACCBU
	pop	ACCAL
	pop	ACCAH
	pop	ACCAU
	pop	w10
	pop	w8
	pop	w5
	pop	w4
	pop	w1
	pop	w0
	return

	.END

